/* Copyright (C) 2005,2006 G.P. Halkes
   Licensed under the Open Software License version 2.0 */

#ifndef GENERATE_H
#define GENERATE_H

#include "io.h"

#define STORAGE_STATIC "static "
#define STORAGE_EXTERN "extern "
#define STORAGE_GLOBAL ""

/* From generateCommon.c */
char *createNameWithExtension(const char *originalName, const char *extension);
void outputCode(File *output, CCode *code, bool keepMarkers);

void generateParserDeclarations(File *output);

void generateHeaderFileTop(File *output);
void generateHeaderFile(File *output);

void generateDefaultPrefixTranslations(File *output);

void generateDefaultLocalDeclarations(File *output, const char *headerName);
void generateDirectiveDeclarations(File *output);
void generatePrototypes(File *output);

void generateConversionTables(File *output, const char *storageType);
void generateSymbolTable(File *output);

typedef enum {
	DIR_PUSH,
	DIR_POP
} PushDirection;

void generateSetPushPop(File *output, const set tokens, PushDirection direction);

void generateDefaultGlobalDeclarations(File *output, const char *headerName);

void generateDirectiveCodeAtEnd(File *output);

extern int labelCounter;
typedef enum {
	POP_NEVER = 0,
	POP_ALWAYS,
	POP_CONDITIONAL
} PopType;

void termGenerateCode(File *output, Term *term, const bool canSkip, PopType popType);

void generateNonTerminalCode(File *output, NonTerminal *nonTerminal);

/* From generateTS.c */
extern const char *userDataTypeTS, *userDataTypeHeaderTS;

void generateHeaderFileTS(File *output);
void generatePrototypesTS(File *output);
void generateDefaultGlobalDeclarationsTS(File *output, const char *headerName);
void generateDirectiveCodeAtEndTS(File *output);
void generateNonTerminalCodeTS(File *output, NonTerminal *nonTerminal);

/* From generate.c */
void generate(void);
void generateTS(void);

/* From generateLLgenStyle.c */
void generateLLgenStyle(void);


extern const char *lexerWrapperString,
	*llmessageString[2];
#endif
