/* Copyright (C) 2005,2006 G.P. Halkes
   Licensed under the Open Software License version 2.0 */
 
#ifndef LEXER_H
#define LEXER_H

#include "bool.h"

/* Current line in the input */
extern int lineNumber;
/* codeStart is the line number of the first line of a code segment. lineNumber
   cannot be used because it may be multiline. */
extern int codeStart;
/* Current input file name */
extern const char *fileName;

extern char *yytext;
extern FILE *yyin;
/* stack of input files used by the lexer */
extern List *inputStack;

extern List *includedFiles;

void openFirstInput(void);
bool nextFile(void);

/* Function defined in the lexer */
bool openInclude(Token *file);

#ifdef MEM_DEBUG
void cleanUpLexer(void);
#endif
#endif
