/* Copyright (C) 2005,2006 G.P. Halkes
   Licensed under the Open Software License version 2.0 */

#ifndef LIST_H
#define LIST_H

typedef struct {
	int fill, maxFill;
	void **data;
} List;


List *newList(void);
void listAppend(List *list, void *data);
void listPrepend(List *list, void *data);
void *listPop(List *list);
void *listIndex(List *list, int idx);
int listSize(List *list);
void listMerge(List *dest, List *src);
void deleteList(List *list);
void listClear(List *list);
void listDelete(List *list, int idx);
void listReplace(List *list, int idx, void *data);
void listInsert(List *list, int idx, void *data);
#endif
