/* Copyright (C) 2005,2006 G.P. Halkes
   Licensed under the Open Software License version 2.0 */

#ifndef SCOPE_H
#define SCOPE_H

#include "bool.h"

#define HASHTABLE_SIZE 257

typedef struct Tuple {
	const char *key;
	void *data;
	struct Tuple *next;	/* Linked list */
} Tuple;

typedef struct {
	Tuple *table[HASHTABLE_SIZE];
} Scope;

Scope *newScope(void);
void *lookup(Scope *scope, const char *key);
bool declare(Scope *scope, const char *key, void *data);
void deleteScope(Scope *scope);
#endif
