/* Copyright (C) 2005,2006 G.P. Halkes
   Licensed under the Open Software License version 2.0 */

#ifndef SET_H
#define SET_H

#include "bool.h"

typedef struct {
	int size;
	int *bits;
} set;

set newSet(int items);
void deleteSet(set a);
bool setUnion(set a, const set b);
bool setIntersection(set a, const set b);
bool setIntersectionEmpty(const set a, const set b);
bool setSet(set a, int i);
bool setContains(const set a, int i);
void setCopy(set a, const set b);
void setClear(set a);
bool setMinus(set a, const set b);
bool setEmpty(const set a);
bool setEquals(const set a, const set b);
int setFill(const set a);
int setFirstToken(const set a);
int setFindIndex(const set a, bool create);

extern int numberOfSets;
extern set *setList;

#endif
